/**
 * Copyright (c) 2012 EBMWebsourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.probes.api.key;

import org.ow2.petals.probes.api.enums.ExecutionStatus;

/**
 * Interface used by key needed by keyed probes grouping values by execution
 * status. It's a wrapper of the initial applicative key and execution status.
 * 
 * @param <K>
 *            Type of the initial key grouping values, implementing
 *            {@link ProbeKey}.
 * 
 * @author Christophe DENEUX (PetalsLink)
 * 
 */
public interface ExecutionStatusProbeKey<K extends ProbeKey> extends ProbeKey {

    /**
     * @return the initial key used to group values.
     */
    public K getOriginalKey();

    /**
     * @return The execution status part of the key
     */
    public ExecutionStatus getExecutionStatus();

}
