/**
 * Copyright (c) 2012 EBMWebsourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.probes.api.key;

/**
 * Interface used by key needed by keyed probes.
 * 
 * 
 * @author Christophe DENEUX (PetalsLink)
 * 
 */
public interface ProbeKey {

    /**
     * Converts the key values as simple values.
     * 
     * @return Key parts as {@link String}[].
     */
    public String[] toStringArray();

    /**
     * Converts the key values as a simple {@link String} value.
     * 
     * @return Key parts as {@link String}.
     */
    public String toReadableString();

}
