/**
 * Copyright (c) 2012 EBMWebsourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.probes.api.sensor;

/**
 * The sensor associated to a gauge probe
 * 
 * @author Christophe DENEUX (PetalsLink)
 * 
 * @param <T>
 *            The type of measured values.
 * @param <S>
 *            The type of value to return to client probe
 */
public interface GaugeSensor<T, S> extends Sensor<T, S> {
    /**
     * Returns the initial value of the sensor.
     * 
     * @return The initial value of the sensor.
     */
    public T getInitialValue();

    /**
     * <p>
     * Returns the instant value of the sensor.
     * </p>
     * <p>
     * <b>MUST</b> be thread safe.
     * </p>
     * 
     * @return The instant value of the sensor.
     */
    public T getInstantValue();
}